/*
 * StringAccess.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef STRING_ACCESS_H_
#define STRING_ACCESS_H_

#include <core/multipleDispatch.hpp>

#include "string/String.h"
#include "string/StringFeatures.h"

#include "settings/StringSettings.h"
#include "settings/OperationSettings.h"
#include <set>

class StringAccess : public alib::SingleDispatch < StringAccess, void, string::StringBase &, const StringSettings::Settings &, const OperationSettings::Settings &, std::deque < sax::Token > & > {
public:
	static void access ( string::String & string, const StringSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );

	static void access ( string::LinearString < > & string, const StringSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );
	static void access ( string::CyclicString < > & string, const StringSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );
};

#endif /* STRING_ACCESS_H_ */
