/*
 * AccessHelpers.h
 *
 *  Created on: 5. 8. 2016
 *	  Author: Jan Travnicek
 */

#ifndef ACCESS_HELPERS_HPP_
#define ACCESS_HELPERS_HPP_

template < class Element, class DataType >
void handleElement ( DataType & data, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument ) {
	typedef typename std::remove_const < typename std::remove_reference < decltype ( data.template accessElement < Element > ( ).get ( ) ) >::type >::type ElementDataType;

	if ( operation == OperationSettings::Settings::GET ) {
		alib::XmlDataFactory::toStdout ( data.template accessElement < Element > ( ).get ( ) );
	}

	if ( operation == OperationSettings::Settings::SET ) {
		ElementDataType symbols = alib::XmlDataFactory::fromTokens ( std::move ( argument ) );

		data.template accessElement < Element > ( ).set ( std::move ( symbols ) );

		alib::XmlDataFactory::toStdout ( data );
	}

	if ( operation == OperationSettings::Settings::ADD || operation == OperationSettings::Settings::REMOVE )
		throw exception::CommonException ( "Invalid access operation" );
}

template < class Component, class DataType >
void handleComponent ( DataType & data, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument ) {
	typedef typename std::remove_const < typename std::remove_reference < decltype ( data.template accessComponent < Component > ( ).get ( ) ) >::type >::type ComponentDataType;

	if ( operation == OperationSettings::Settings::GET ) {
		alib::XmlDataFactory::toStdout ( data.template accessComponent < Component > ( ).get ( ) );
	}

	if ( operation == OperationSettings::Settings::ADD ) {
		ComponentDataType symbols = alib::XmlDataFactory::fromTokens ( std::move ( argument ) );

		data.template accessComponent < Component > ( ).add ( std::move ( symbols ) );

		alib::XmlDataFactory::toStdout ( data );
	}

	if ( operation == OperationSettings::Settings::SET ) {
		ComponentDataType symbols = alib::XmlDataFactory::fromTokens ( std::move ( argument ) );

		data.template accessComponent < Component > ( ).set ( std::move ( symbols ) );

		alib::XmlDataFactory::toStdout ( data );
	}

	if ( operation == OperationSettings::Settings::REMOVE ) {
		ComponentDataType symbols = alib::XmlDataFactory::fromTokens ( std::move ( argument ) );

		data.template accessComponent < Component > ( ).remove ( std::move ( symbols ) );

		alib::XmlDataFactory::toStdout ( data );
	}
}

#endif /* ACCESS_HELPERS_HPP_ */
