/*
 * GrammarSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __GRAMMAR_SETTINGS_H__
#define __GRAMMAR_SETTINGS_H__

#include "SettingsHelper.h"

class GrammarEnum {
public:
	enum class Settings {
		NONTERMINALS, TERMINALS, INITIAL_SYMBOLS, RULES, __MAX__
	};

	static std::string toString ( GrammarEnum::Settings settings ) {
		switch ( settings ) {
		case GrammarEnum::Settings::NONTERMINALS:
			return "nonterminals";

		case GrammarEnum::Settings::TERMINALS:
			return "terminals";

		case GrammarEnum::Settings::INITIAL_SYMBOLS:
			return "initial_symbols";

		case GrammarEnum::Settings::RULES:
			return "rules";

		case GrammarEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class GrammarSettings : public GrammarEnum, public EnumClassHelper < GrammarEnum > {
};

#endif /* __GRAMMAR_SETTINGS_H__ */
