/*
 * OperationSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __OPERATION_SETTINGS_H__
#define __OPERATION_SETTINGS_H__

#include "SettingsHelper.h"

class OperationEnum {
public:
	enum class Settings {
		GET, SET, ADD, REMOVE, __MAX__
	};

	static std::string toString ( OperationEnum::Settings settings ) {
		switch ( settings ) {
		case OperationEnum::Settings::GET:
			return "get";

		case OperationEnum::Settings::SET:
			return "set";

		case OperationEnum::Settings::ADD:
			return "add";

		case OperationEnum::Settings::REMOVE:
			return "remove";

		case OperationEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class OperationSettings : public OperationEnum, public EnumClassHelper < OperationEnum > {
};

#endif /* __OPERATION_SETTINGS_H__ */
