/*
 * RegExpSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __REG_EXP_SETTINGS_H__
#define __REG_EXP_SETTINGS_H__

#include "SettingsHelper.h"

class RegExpEnum {
public:
	enum class Settings {
		ALPHABET, CONTENT, __MAX__
	};

	static std::string toString ( RegExpEnum::Settings settings ) {
		switch ( settings ) {
		case RegExpEnum::Settings::ALPHABET:
			return "alphabet";

		case RegExpEnum::Settings::CONTENT:
			return "content";

		case RegExpEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class RegExpSettings : public RegExpEnum, public EnumClassHelper < RegExpEnum > {
};

#endif /* __REG_EXP_SETTINGS_H__ */
