/*
 * StringCompare.h
 *
 *  Created on: Apr 4, 2017
 *      Author: Tomas Pecka
 */

#ifndef STRING_COMPARE_H_
#define STRING_COMPARE_H_

#include <core/multipleDispatch.hpp>
#include <ostream>

#include <string/String.h>
#include <string/StringFeatures.h>

#include <utility>
#include <vector>

class StringCompare : public alib::DoubleDispatch < StringCompare, int, const string::StringBase &, const string::StringBase & > {
private:
	static bool testCompare ( const string::LinearString < > & a, const string::LinearString < > & b );
	static void printCompare ( const string::LinearString < > & a, const string::LinearString < > & b );

	static bool testCompare ( const string::CyclicString < > & a, const string::CyclicString < > & b );
	static void printCompare ( const string::CyclicString < > & a, const string::CyclicString < > & b );

	template < class T >
	static void setCompare ( const std::set < T > a, const std::set < T > b );
	template < class T >
	static void vectorCompare ( const std::vector < T > a, const std::vector < T > b );

public:
	template < class T >
	static int compare ( const T & a, const T & b );

	static int compare ( const string::String & a, const string::String & b );
};

template < class T >
int StringCompare::compare ( const T & a, const T & b ) {
	if ( !StringCompare::testCompare ( a, b ) ) {
		StringCompare::printCompare ( a, b );
		return 1;
	} else {
		return 0;
	}
}

#endif /* GRAMMAR_COMPARE_H_ */
