/*
 * UsefullStates.cpp
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "UsefullStates.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace properties {

std::set < DefaultStateType > UsefullStates::usefullStates(const Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto UsefullStatesEpsilonNFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::EpsilonNFA < > > ( UsefullStates::usefullStates );
auto UsefullStatesNFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::NFA < > > ( UsefullStates::usefullStates );
auto UsefullStatesCompactNFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::CompactNFA < > > ( UsefullStates::usefullStates );
auto UsefullStatesExtendedNFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::ExtendedNFA < > > ( UsefullStates::usefullStates );
auto UsefullStatesMultiInitialStateNFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::MultiInitialStateNFA < > > ( UsefullStates::usefullStates );
auto UsefullStatesDFA = registration::OverloadRegister < UsefullStates, std::set < DefaultStateType >, automaton::DFA < > > ( UsefullStates::usefullStates );

} /* namespace properties */

} /* namespace automaton */

