/*
 * Accept.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Accept.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

bool Accept::accept ( const automaton::Automaton & automaton, const alib::Object & object ) {
	return dispatch ( automaton.getData ( ), object.getData ( ) );
}

bool Accept::accept ( const automaton::Automaton & automaton, const string::LinearString < > & string ) {
	return dispatch ( automaton.getData ( ), string );
}

bool Accept::accept ( const automaton::Automaton & automaton, const tree::RankedTree < > & tree ) {
	return dispatch ( automaton.getData ( ), tree );
}

auto AcceptDFALinearString = registration::OverloadRegister < Accept, bool, automaton::DFA < >, string::LinearString < > > ( Accept::accept );
auto AcceptNFALinearString = registration::OverloadRegister < Accept, bool, automaton::NFA < >, string::LinearString < > > ( Accept::accept );
auto AcceptDFTARankedTree = registration::OverloadRegister < Accept, bool, automaton::DFTA < >, tree::RankedTree < > > ( Accept::accept );
auto AcceptNFTARankedTree = registration::OverloadRegister < Accept, bool, automaton::NFTA < >, tree::RankedTree < > > ( Accept::accept );
auto AcceptInputDrivenDPDALinearString = registration::OverloadRegister < Accept, bool, automaton::InputDrivenDPDA < >, string::LinearString < > > ( Accept::accept );
auto AcceptVisiblyPushdownDPDALinearString = registration::OverloadRegister < Accept, bool, automaton::VisiblyPushdownDPDA < >, string::LinearString < > > ( Accept::accept );
auto AcceptRealTimeHeightDeterministicDPDALinearString = registration::OverloadRegister < Accept, bool, automaton::RealTimeHeightDeterministicDPDA < >, string::LinearString < > > ( Accept::accept );
auto AcceptDPDALinearString = registration::OverloadRegister < Accept, bool, automaton::DPDA < >, string::LinearString < > > ( Accept::accept );
auto AcceptNPDTALinearString = registration::OverloadRegister < Accept, bool, automaton::NPDTA < >, string::LinearString < > > ( Accept::accept );

} /* namespace run */

} /* namespace automaton */
