/*
 * EpsilonRemoverOutgoing.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "EpsilonRemoverOutgoing.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto EpsilonRemoverOutgoingDFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::DFA < >, automaton::DFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingMultiInitialStateNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < > , automaton::MultiInitialStateNFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::NFA < > , automaton::NFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingEpsilonNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < > , automaton::EpsilonNFA < > > ( EpsilonRemoverOutgoing::remove );

automaton::Automaton EpsilonRemoverOutgoing::remove(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

} /* namespace simplify */

} /* namespace automaton */
