/*
 * Minimize.cpp
 *
 *  Created on: Dec 9, 2013
 *	  Author: honza
 */

#include "Minimize.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

automaton::Automaton Minimize::minimize(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto MinimizeNFA = registration::OverloadRegister < Minimize, automaton::DFA < >, automaton::DFA < > >( Minimize::minimize );
auto MinimizeNFA2 = registration::AbstractRegister < Minimize, automaton::DFA < >, const automaton::DFA < > & > ( Minimize::minimize );
auto MinimizeNFTA = registration::OverloadRegister < Minimize, automaton::DFTA < >, automaton::DFTA < > >( Minimize::minimize );

} /* namespace simplify */

} /* namespace automaton */
