/*
 * Rename.h
 *
 *  Created on: Dec 9, 2013
 *      Author: Jan Travnicek
 */

#ifndef RENAME_H_
#define RENAME_H_

#include <core/multipleDispatch.hpp>
#include <automaton/FSM/DFA.h>
#include <automaton/PDA/DPDA.h>
#include <automaton/PDA/SinglePopDPDA.h>
#include <automaton/PDA/InputDrivenDPDA.h>
#include <automaton/PDA/VisiblyPushdownDPDA.h>
#include <automaton/PDA/RealTimeHeightDeterministicDPDA.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class Rename : public alib::SingleDispatch<Rename, automaton::Automaton, const automaton::AutomatonBase &> {
public:
	/**
	 * @param dfa automaton to rename
	 */
	static automaton::Automaton rename(const automaton::Automaton& dfa);

	static automaton::DFA<> rename(const automaton::DFA<>& dfa);
	static automaton::DPDA < > rename(const automaton::DPDA < > & pda);
	static automaton::SinglePopDPDA < > rename(const automaton::SinglePopDPDA < > & pda);
	static automaton::InputDrivenDPDA < > rename(const automaton::InputDrivenDPDA < > & pda);
	static automaton::VisiblyPushdownDPDA < > rename(const automaton::VisiblyPushdownDPDA < > & pda);
	static automaton::RealTimeHeightDeterministicDPDA < > rename(const automaton::RealTimeHeightDeterministicDPDA < > & pda);
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* RENAME_H_ */
