/*
 * AutomataConcatenation.cpp
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "AutomataConcatenation.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

automaton::Automaton AutomataConcatenation::concatenation(const automaton::Automaton& first, const automaton::Automaton& second) {
	return dispatch(first.getData(), second.getData());
}

auto AutomataConcatenationNFA = registration::OverloadRegister < AutomataConcatenation, automaton::NFA < >, automaton::NFA < > > ( AutomataConcatenation::concatenation );
auto AutomataConcatenationDFA = registration::OverloadRegister < AutomataConcatenation, automaton::NFA < >, automaton::DFA < > > ( AutomataConcatenation::concatenation );

} /* namespace transform */

} /* namespace automaton */
