/*
 * ToRegExp.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExp.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace convert {

regexp::RegExp ToRegExp::convert(const grammar::Grammar& grammar) {
	return dispatch(grammar.getData());
}

auto ToRegExpRightRG = registration::OverloadRegister < ToRegExp, regexp::RegExp, grammar::RightRG < > > ( ToRegExp::convert );
auto ToRegExpLeftRG = registration::OverloadRegister < ToRegExp, regexp::RegExp, grammar::LeftRG < > > ( ToRegExp::convert );

} /* namespace convert */

} /* namespace grammar */
