/*
 * RandomizeGrammar.cpp
 *
 *  Created on: 9. 2. 2017
 *	  Author: Jan Travnicek
 */

#include "RandomizeGrammar.h"
#include <grammar/Grammar.h>
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace generate {

auto RandomizeGrammarLeftRG = registration::OverloadRegister < RandomizeGrammar, grammar::LeftRG < >, grammar::LeftRG < > > ( RandomizeGrammar::randomize );
auto RandomizeGrammarLeftLG = registration::OverloadRegister < RandomizeGrammar, grammar::LeftLG < >, grammar::LeftLG < > > ( RandomizeGrammar::randomize );
auto RandomizeGrammarRightRG = registration::OverloadRegister < RandomizeGrammar, grammar::RightRG < >, grammar::RightRG < > > ( RandomizeGrammar::randomize );
auto RandomizeGrammarRightLG = registration::OverloadRegister < RandomizeGrammar, grammar::RightLG < >, grammar::RightLG < > > ( RandomizeGrammar::randomize );
auto RandomizeGrammarCFG = registration::OverloadRegister < RandomizeGrammar, grammar::CFG < >, grammar::CFG < > > ( RandomizeGrammar::randomize );

grammar::Grammar RandomizeGrammar::randomize ( const grammar::Grammar & grammar ) {
	return dispatch ( grammar.getData ( ) );
}

} /* namespace generate */

} /* namespace grammar */
