/*
 * ProductiveNonterminals.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ProductiveNonterminals.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace properties {

auto ProductiveNonterminalsCFG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::CFG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsEpsilonFreeCFG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::EpsilonFreeCFG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsGNF = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::GNF < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsCNF = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::CNF < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsLG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::LG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsLeftLG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::LeftLG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsLeftRG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::LeftRG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsRightLG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::RightLG < > > ( ProductiveNonterminals::getProductiveNonterminals );
auto ProductiveNonterminalsRightRG = registration::OverloadRegister < ProductiveNonterminals, std::set < DefaultSymbolType >, grammar::RightRG < > > ( ProductiveNonterminals::getProductiveNonterminals );

std::set<DefaultSymbolType> ProductiveNonterminals::getProductiveNonterminals(const grammar::Grammar& grammar ) {
	return dispatch(grammar.getData());
}

} /* namespace properties */

} /* namespace grammar */
