/*
 * ToGrammar.h
 *
 *  Created on: 6. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_TO_GRAMMAR_H_
#define REG_EXP_TO_GRAMMAR_H_

#include <core/multipleDispatch.hpp>

#include <grammar/Grammar.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpFeatures.h>

#include "ToGrammarRightRGGlushkov.h"

namespace regexp {

namespace convert {

class ToGrammar : public alib::SingleDispatch<ToGrammar, grammar::Grammar, const regexp::RegExpBase &> {
public:
	/**
	 * Performs conversion.
	 * @return right regular grammar equivalent to source regexp.
	 */
	static grammar::Grammar convert(const regexp::RegExp& regexp);

	template < class SymbolType >
	static grammar::Grammar convert(const regexp::FormalRegExp < SymbolType > & regexp);
	template < class SymbolType >
	static grammar::Grammar convert(const regexp::UnboundedRegExp < SymbolType > & regexp);

};

template < class SymbolType >
grammar::Grammar ToGrammar::convert(const regexp::FormalRegExp < SymbolType > & regexp) {
	return grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

template < class SymbolType >
grammar::Grammar ToGrammar::convert(const regexp::UnboundedRegExp < SymbolType > & regexp) {
	return grammar::Grammar(ToGrammarRightRGGlushkov::convert(regexp));
}

} /* namespace convert */

} /* namespace regexp */

#endif /* REG_EXP_TO_GRAMMAR_H_ */
