/*
 * ToPostfixPushdownAutomatonGlushkov.h
 *
 *  Created on: 11. 4. 2016
 *	  Author: Tomas Pecka
 */

#ifndef TO_POSTFIX_PUSHDOWN_AUTOMATON_GLUSHKOV_H_
#define TO_POSTFIX_PUSHDOWN_AUTOMATON_GLUSHKOV_H_

#include <core/multipleDispatch.hpp>
#include <map>

#include <automaton/FSM/NFA.h>
#include <automaton/PDA/NPDA.h>
#include <rte/RTE.h>
#include <rte/formal/FormalRTE.h>

// #include <rte/unbounded/UnboundedRegExp.h>

namespace rte {

namespace convert {

/**
 * Converts regular tree expression to real-time height-deterministic pda
 * Source: Master Thesis, Pecka Tomas, CTU FIT, 2016, chapter 4.2
 */
class ToPostfixPushdownAutomatonGlushkov : public alib::SingleDispatch < ToPostfixPushdownAutomatonGlushkov, automaton::NPDA < >, const rte::RTEBase & > {
public:
	/**
	 * Performs conversion.
	 * @param re Original regular tree expression.
	 * @return rhNPDA equivalent to original regular expression.
	 */
	static automaton::NPDA < > convert ( const rte::RTE & rte );
	static automaton::NPDA < > convert ( const rte::FormalRTE < > & rte );
};

} /* namespace convert */

} /* namespace rte */

#endif /* TO_POSTFIX_PUSHDOWN_AUTOMATON_GLUSHKOV_H_ */
