/*
 * BoyerMooreHorspool.cpp
 *
 *  Created on: 5. 11. 2014
 *      Author: Radomir Polach, Tomas Pecka
 */

#include "BoyerMooreHorspool.h"
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace exact {

std::set<unsigned> BoyerMooreHorspool::match(const string::String& subject, const string::String& pattern) {
	return dispatch(subject.getData(), pattern.getData());
}

auto BoyerMooreHorspoolLinearStringLinearString = registration::OverloadRegister < BoyerMooreHorspool, std::set < unsigned >, string::LinearString < >, string::LinearString < > > ( BoyerMooreHorspool::match );

} /* namespace exact */

} /* namespace stringology */
