/*
 * ExactNondeterministicSubsequenceAutomaton.cpp
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#include "ExactNondeterministicSubsequenceAutomaton.h"
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace indexing {

automaton::Automaton ExactNondeterministicSubsequenceAutomaton::construct(const string::String& text) {
	return dispatch(text.getData());
}

auto ExactNondeterministicSubsequenceAutomatonLinearString = registration::OverloadRegister < ExactNondeterministicSubsequenceAutomaton, automaton::EpsilonNFA < DefaultSymbolType, DefaultEpsilonType, unsigned >, string::LinearString < > > ( ExactNondeterministicSubsequenceAutomaton::construct );

} /* namespace indexing */

} /* namespace stringology */
