/*
 * DeterministicLL1ParseTable.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#ifndef DETERMINISTIC_LL_1_PARSE_TABLE_H_
#define DETERMINISTIC_LL_1_PARSE_TABLE_H_

#include <alphabet/Symbol.h>
#include <string/Epsilon.h>
#include <vector>
#include <variant>
#include <set>
#include <map>

namespace grammar {

namespace parsing {

class DeterministicLL1ParseTable {
public:
	static std::map < std::pair < ext::variant < DefaultSymbolType, string::Epsilon < > >, DefaultSymbolType >, std::vector < DefaultSymbolType > > parseTable ( const std::map < std::pair < ext::variant < DefaultSymbolType, string::Epsilon < > >, DefaultSymbolType >, std::set < std::vector < DefaultSymbolType > > > & parseTable );
};

} /* namespace parsing */

} /* namespace grammar */

#endif /* DETERMINISTIC_LL_1_PARSE_TABLE_H_ */
