/*
 * First.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Tomas Pecka, Jan Travnicek
 */

#ifndef FIRST_H_
#define FIRST_H_

#include <core/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>
#include <string/Epsilon.h>
#include <vector>
#include <set>
#include <variant>

namespace grammar {

namespace parsing {

class First;

typedef std::map < std::vector < DefaultSymbolType >, std::set < ext::variant < DefaultSymbolType, string::Epsilon < > > > > FirstResult1;
typedef alib::SingleDispatch < First, FirstResult1, const grammar::GrammarBase & > FirstBase1;

typedef std::set < ext::variant < DefaultSymbolType, string::Epsilon < > > > FirstResult2;
typedef alib::SingleDispatch < First, FirstResult2, const grammar::GrammarBase &, const std::vector < DefaultSymbolType > & > FirstBase2;

class First : public FirstBase1, public FirstBase2 {
	static std::set < ext::variant < DefaultSymbolType, string::Epsilon < > > > first ( const std::set < DefaultSymbolType > & terminals, const std::set < DefaultSymbolType > & nonterminals, const std::map < DefaultSymbolType, std::set < ext::variant < DefaultSymbolType, string::Epsilon < > > > > & firstOfNonterminal, const std::vector < DefaultSymbolType > & rhs );

	static std::map < DefaultSymbolType, std::set < ext::variant < DefaultSymbolType, string::Epsilon < > > > > first ( const std::set < DefaultSymbolType > & terminals, const std::set < DefaultSymbolType > & nonterminals, const std::map < DefaultSymbolType, std::set < std::vector < DefaultSymbolType > > > & rules );

public:
	template < class T >
	static FirstResult1 first ( const T & grammar );

	template < class T >
	static FirstResult2 first ( const T & grammar, const std::vector < DefaultSymbolType > & rhs );

	static FirstResult1 first ( const grammar::Grammar & grammar );

	static FirstResult2 first ( const grammar::Grammar & grammar, const std::vector < DefaultSymbolType > & rhs );

};

} /* namespace parsing */

} /* namespace grammar */

#endif /* FIRST_H_ */
