/*
 * LL1ParseTable.h
 *
 *  Created on: 9. 6. 2015
 *	  Author: Jan Travnicek
 */

#ifndef LL_1_PARSE_TABLE_H_
#define LL_1_PARSE_TABLE_H_

#include <core/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <alphabet/Symbol.h>
#include <string/Epsilon.h>
#include <vector>
#include <variant>
#include <set>
#include <map>

namespace grammar {

namespace parsing {

class LL1ParseTable : public alib::SingleDispatch < LL1ParseTable, std::map < std::pair < ext::variant < DefaultSymbolType, string::Epsilon < > >, DefaultSymbolType >, std::set < std::vector < DefaultSymbolType > > >, const grammar::GrammarBase & > {
public:
	template < class T >
	static std::map < std::pair < ext::variant < DefaultSymbolType, string::Epsilon < > >, DefaultSymbolType >, std::set < std::vector < DefaultSymbolType > > > parseTable ( const T & grammar );

	static std::map < std::pair < ext::variant < DefaultSymbolType, string::Epsilon < > >, DefaultSymbolType >, std::set < std::vector < DefaultSymbolType > > > parseTable ( const grammar::Grammar & grammar );

};

} /* namespace parsing */

} /* namespace grammar */

#endif /* LL_1_PARSE_TABLE_H_ */
