/*
 * Kruskal.h
 *
 *   Created on: Mar 26, 2016
 *       Author: Jan Broz
 */

#ifndef GRAPH_KRUSKAL
#define GRAPH_KRUSKAL

#include <core/multipleDispatch.hpp>
#include <graph/GraphClasses.h>

namespace graph {

namespace spanningtree {

class Kruskal : public alib::SingleDispatch< Kruskal, graph::Graph, const graph::GraphBase & > {
public:

	static Graph kruskal( const Graph & graph );

	static AdjacencyListUndirectedGraph kruskal( const UndirectedGraph & graph );

	static Kruskal & getInstance() {
		static Kruskal res;
		return res;
	}

};

} // namespace spanningtree

} // namespace graph

#endif // GRAPH_KRUSKAL
