#ifndef _CLI_BINDED_FILE_PARAM_H_
#define _CLI_BINDED_FILE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class BindedFileParam : public Param {
	std::string m_bind;

public:
	BindedFileParam ( std::string bind ) : m_bind ( bind ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		std::deque < sax::Token > tokens = sax::FromXMLParserHelper::parseInput ( environment.getBinding ( m_bind ) );
		std::string type = tokens [ 0 ].getData ( );
		return abstraction::Registry::getXmlParserAbstraction ( type, tokens );
	}
};

} /* namespace cli */

#endif /* _CLI_BINDED_FILE_PARAM_H_ */
