#ifndef _CAST_PARAM_H_
#define _CAST_PARAM_H_

#include <ast/Param.h>

namespace cli {

class CastParam : public Param {
	std::string m_type;
	std::unique_ptr < Param > m_param;

public:
	CastParam ( std::string type, std::unique_ptr < Param > param ) : m_type ( std::move ( type ) ), m_param ( std::move ( param ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		std::shared_ptr < abstraction::OperationAbstraction > translatedParam = m_param->translateAndEval ( prev, environment  );

		std::shared_ptr < abstraction::OperationAbstraction > res = translatedParam->getCastFromResult ( m_type );
		res->attachInput ( translatedParam, 0 );
		res->eval ( );

		return res;
	}

};

} /* namespace cli */

#endif /* _CAST_PARAM_H_ */
