#ifndef _IMMEDIATE_VALUE_PARAM_H_
#define _IMMEDIATE_VALUE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

template < class Type >
class ImmediateValueParam : public Param {
	Type m_data;

public:
	ImmediateValueParam ( Type value ) : m_data ( value ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < Type > > ( m_data );
	}

};

} /* namespace cli */

#endif /* _IMMEDIATE_VALUE_PARAM_H_ */
