#ifndef _CLI_BINDED_VALUE_STATEMENT_H_
#define _CLI_BINDED_VALUE_STATEMENT_H_

#include <ast/Statement.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

class BindedValueStatement : public Statement {
	std::string m_bind;

public:
	BindedValueStatement ( std::string bind ) : m_bind ( std::move ( bind ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < std::string > > ( environment.getBinding ( m_bind ) );
	}
};

} /* namespace cli */

#endif /* _CLI_BINDED_VALUE_STATEMENT_H_ */
