#ifndef _CLI_RESULT_IMMEDIATE_FILE_STATEMENT_H_
#define _CLI_RESULT_IMMEDIATE_FILE_STATEMENT_H_

#include <ast/Statement.h>

namespace cli {

class ResultImmediateFileStatement : public Statement {
	std::string m_name;

public:
	ResultImmediateFileStatement ( std::string name ) : m_name ( name ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & ) const override {
		std::shared_ptr < abstraction::OperationAbstraction > res = prev->getXmlFileWriterFromResult ( m_name );
		res->attachInput ( prev, 0 );
		res->eval ( );
		return res;
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_IMMEDIATE_FILE_STATEMENT_H_ */
