#ifndef _CLI_RESULT_VARIABLE_STATEMENT_H_
#define _CLI_RESULT_VARIABLE_STATEMENT_H_

#include <ast/Statement.h>

namespace cli {

class ResultVariableStatement : public Statement {
	std::string m_bind;

public:
	ResultVariableStatement ( std::string bind ) : m_bind ( bind ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		environment.setVariable ( m_bind, prev );
		return prev;
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_VARIABLE_STATEMENT_H_ */
