/*
 * XmlFileWriterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_FILE_WRITER_ABSTRACTION_HPP_
#define _XML_FILE_WRITER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

template < class ParamType >
class XmlFileWriterAbstraction : public UnaryOperationAbstraction < void, ParamType > {
	std::string m_filename;

public:
	XmlFileWriterAbstraction ( std::string filename ) : m_filename ( filename ) {
	}

	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		alib::XmlDataFactory::toFile ( this->m_param->getData ( ), m_filename );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_FILE_WRITER_ABSTRACTION_HPP_ */
