/*
 * XmlParserAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _XML_PARSER_ABSTRACTION_HPP_
#define _XML_PARSER_ABSTRACTION_HPP_

#include <abstraction/NullaryOperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

template < class ReturnType >
class XmlParserAbstraction : public NullaryOperationAbstraction < ReturnType > {
	std::deque < sax::Token > m_tokens;

public:
	XmlParserAbstraction ( std::deque < sax::Token > tokens ) : m_tokens ( std::move ( tokens ) ) {
	}

	virtual bool run ( ) override {
		if ( this->m_data != nullptr )
			return true;

		ReturnType res = alib::XmlDataFactory::fromTokens ( std::move ( m_tokens ) );
		this->m_data = std::unique_ptr < ReturnType > ( static_cast < ReturnType * > ( std::move ( res ).plunder ( ) ) );
		return true;
	}
};

} /* namespace abstraction */

#endif /* _XML_PARSER_ABSTRACTION_HPP_ */
