/*
 * namingApi.hpp
 *
 * Created on: Jul 7, 2017
 * Author: Jan Travnicek
 */

#ifndef NAMING_API_HPP_
#define NAMING_API_HPP_

#include <map>
#include <set>
#include <string>
#include <typeindex>

#include <exception/CommonException.h>

namespace alib {

class namingApi {
	static std::map < std::string, std::set < std::type_index > > & getNames ( ) {
		static std::map < std::string, std::set < std::type_index > > names;
		return names;
	}

public:
	template < typename Type >
	static void registerName ( std::string name ) {
		std::type_index type = std::type_index ( typeid ( Type ) );
		std::pair < std::set < std::type_index >::iterator, bool > res = getNames ( ) [ name ].insert ( type );
		if ( ! res.second && * res.first != type )
			throw exception::CommonException ( "Type for name " + name + " already registered.");
	}

	static std::set < std::type_index > & getTypes ( std::string stringname ) {
		auto name = getNames ( ).find ( stringname );
		if ( name == getNames ( ).end ( ) )
			throw exception::CommonException ( "Types for name " + stringname + " not registered.");

		return name->second;
	}

};

} /* namespace alib */

#endif /* CAST_API_HPP_ */
