/*
 * Casts.hpp
 *
 *  Created on: 12. 2. 2017
 *      Author: Jan Travnicek
 */

#ifndef CASTS_HPP_
#define CASTS_HPP_

#include <string>
#include <set>
#include <map>
#include <typeinfo>

namespace introspection {

class Casts {
	static std::map < std::string, std::set < std::string > > & castsFrom ( ) {
		static std::map < std::string, std::set < std::string > > res;
		return res;
	}

	static std::map < std::string, std::set < std::string > > & castsTo ( ) {
		static std::map < std::string, std::set < std::string > > res;
		return res;
	}

public:
	static const std::map < std::string, std::set < std::string > > & getCastsFrom ( ) {
		return castsFrom ( );
	}

	static const std::map < std::string, std::set < std::string > > & getCastsTo ( ) {
		return castsTo ( );
	}

	template < class From, class To >
	static void registerCast ( ) {
		std::string fromType = ext::to_string < From > ( );
		std::string toType = ext::to_string < To > ( );

		std::set < std::string > & fromToSet = Casts::castsFrom ( ) [ fromType ];
		std::set < std::string > & toFromSet = Casts::castsTo ( ) [ toType ];
		fromToSet.insert ( std::move ( toType ) );
		toFromSet.insert ( std::move ( fromType ) );
	}

};

} /* namespace introspection */

#endif /* CASTS_HPP_ */

