/*
 * DataTypes.hpp
 *
 *  Created on: 12. 2. 2017
 *      Author: Jan Travnicek
 */

#ifndef DATA_TYPES_HPP_
#define DATA_TYPES_HPP_

#include <string>
#include <set>
#include <map>
#include <typeinfo>

namespace introspection {

class DataTypes {
	static std::map < std::string, std::set < std::string > > & typesInGroup ( ) {
		static std::map < std::string, std::set < std::string > > res;
		return res;
	}

	static std::set < std::string > & groups ( ) {
		static std::set < std::string > res;
		return res;
	}

public:
	static const std::map < std::string, std::set < std::string > > & getTypesInGroup ( ) {
		return typesInGroup ( );
	}

	static const std::set < std::string > & getGroups ( ) {
		return groups ( );
	}

	template < class Type, class Group >
	static void registerTypeInGroup ( ) {
		std::string type = ext::to_string < Type > ( );
		std::string group = ext::to_string < Group > ( );

		DataTypes::typesInGroup ( ) [ group ].insert ( std::move ( type ) );
	}

	template < class Group >
	static void registerGroup ( ) {
		std::string group = ext::to_string < Group > ( );

		DataTypes::groups ( ).insert ( std::move ( group ) );
	}

};

} /* namespace introspection */

#endif /* DATA_TYPES_HPP_ */
