#ifndef _CAST_REGISTRATION_HPP_
#define _CAST_REGISTRATION_HPP_

#include <core/castApi.hpp>
#include <introspection/Casts.hpp>
#include <abstraction/CastRegistry.hpp>

namespace registration {

template < class To, class From >
class CastRegister {
public:
	CastRegister ( ) {
		alib::castApi::getCastPool < To > ( ).template add < From > ( );

		introspection::Casts::registerCast < From, To > ( );

		abstraction::CastRegistry::registerCast < To, From > ( );
	}

	CastRegister ( To ( * castFunction ) ( const From & ) ) {
		alib::castApi::getCastPool < To > ( ).template add < From > ( castFunction );

		introspection::Casts::registerCast < From, To > ( );
	}
};

} /* namespace registration */

#endif // _CAST_REGISTRATION_HPP_
