#ifndef _TYPE_REGISTRATION_HPP_
#define _TYPE_REGISTRATION_HPP_

#include <core/xmlApi.hpp>
#include <introspection/DataTypes.hpp>

#include <abstraction/XmlFileWriterRegistry.hpp>
#include <abstraction/XmlParserRegistry.hpp>
#include <abstraction/ValuePrinterRegistry.hpp>
#include <abstraction/DowncastRegistry.hpp>

namespace registration {

template < class Group, class Type >
class TypeRegister {
public:
	TypeRegister ( ) {
		alib::xmlApi < Group >::template registerType < Type > ( );
		introspection::DataTypes::registerTypeInGroup < Type, Group > ( );
		introspection::DataTypes::registerGroup < Group > ( );

		abstraction::XmlFileWriterRegistry::registerXmlFileWriter < Type > ( );
		abstraction::XmlParserRegistry::registerXmlParser < Type > ( );
		abstraction::ValuePrinterRegistry::registerValuePrinter < Type > ( );

		abstraction::DowncastRegistry::registerDowncast < Type, typename std::decay < decltype ( std::declval < Group > ( ).getData ( ) ) >::type > ( );
	}
};

} /* namespace registration */

#endif // _TYPE_REGISTRATION_HPP_
