#include <list>
#include "AnyObjectTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "object/AnyObject.h"
#include "container/ObjectsPair.h"
#include <primitive/Character.h>

#include "factory/XmlDataFactory.hpp"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( AnyObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( AnyObjectTest );

void AnyObjectTest::setUp ( ) {
}

void AnyObjectTest::tearDown ( ) {
}

void AnyObjectTest::testXMLParser ( ) {

	alib::AnyObject < std::pair < int, char > > object ( std::make_pair ( 1, 'a' ) );
	alib::Object res ( container::ObjectsPair < alib::Object, alib::Object > ( alib::Object ( primitive::Integer ( 1 ) ), alib::Object ( primitive::Character ( 'a' ) ) ) );

	{
		std::string tmp = alib::XmlDataFactory::toString ( object );
		alib::Object object2 = alib::XmlDataFactory::fromString ( tmp );

		CPPUNIT_ASSERT ( res == object2 );
	}
}

