/*
 * SubtreeWildcardSymbol.cpp
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "SubtreeWildcardSymbol.h"
#include <sax/FromXMLParserHelper.h>
#include "Symbol.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include "UniqueSymbol.h"

namespace alphabet {

SubtreeWildcardSymbol::SubtreeWildcardSymbol() {

}

SymbolBase* SubtreeWildcardSymbol::clone() const {
	return new SubtreeWildcardSymbol(*this);
}

SymbolBase* SubtreeWildcardSymbol::plunder() && {
	return new SubtreeWildcardSymbol(std::move(*this));
}

int SubtreeWildcardSymbol::compare(const SubtreeWildcardSymbol&) const {
	return 0;
}

void SubtreeWildcardSymbol::operator>>(std::ostream& out) const {
	out << "(SubtreeWildcardSymbol)";
}

SubtreeWildcardSymbol::operator std::string () const {
	return SubtreeWildcardSymbol::instance < std::string > ( );
}

SubtreeWildcardSymbol SubtreeWildcardSymbol::parse(std::deque<sax::Token>::iterator& input) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, SubtreeWildcardSymbol::getXmlTagName());
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, SubtreeWildcardSymbol::getXmlTagName());
	return SubtreeWildcardSymbol();
}

void SubtreeWildcardSymbol::compose(std::deque<sax::Token>& out) const {
	out.emplace_back(SubtreeWildcardSymbol::getXmlTagName(), sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(SubtreeWildcardSymbol::getXmlTagName(), sax::Token::TokenType::END_ELEMENT);
}

SymbolBase* SubtreeWildcardSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace alib {

auto subtreeWildcardSymbolType = registration::TypeRegister < alphabet::Symbol, alphabet::SubtreeWildcardSymbol > ();
auto subtreeWildcardSymbolType2 = registration::TypeRegister < alib::Object, alphabet::SubtreeWildcardSymbol > ();

} /* namespace alib */
