/*
 * PrefixRankedBarPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedBarPattern.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto prefixRankedBarPatternType = registration::TypeRegister < tree::Tree, tree::PrefixRankedBarPattern < > > ( );
auto prefixRankedBarPatternType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::PrefixRankedBarPattern < > > ( );
auto prefixRankedBarPatternType3 = registration::TypeRegister < alib::Object, tree::PrefixRankedBarPattern < > > ( );

auto PrefixRankedBarPatternFromRankedPattern = registration::CastRegister < tree::PrefixRankedBarPattern < >, tree::RankedPattern < > > ( );
auto PrefixRankedBarPatternFromPrefixRankedBarTree = registration::CastRegister < tree::PrefixRankedBarPattern < >, tree::PrefixRankedBarTree < > > ( );

auto PrefixRankedBarPatternName = registration::NameRegister < tree::PrefixRankedBarPattern < > > ( tree::PrefixRankedBarPattern < >::getXmlTagName ( ) );

} /* namespace alib */
