/*
 * UnrankedPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "UnrankedPattern.h"
#include "../Tree.h"
#include "../UnrankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto unrankedPatternType = registration::TypeRegister < tree::Tree, tree::UnrankedPattern < > > ( );
auto unrankedPatternType2 = registration::TypeRegister < tree::UnrankedTreeWrapper, tree::UnrankedPattern < > > ( );
auto unrankedPatternType3 = registration::TypeRegister < alib::Object, tree::UnrankedPattern < > > ( );

auto UnrankedPatternFromRankedPattern = registration::CastRegister < tree::UnrankedPattern < >, tree::RankedPattern < > > ( );

auto UnrankedPatternName = registration::NameRegister < tree::UnrankedPattern < > > ( tree::UnrankedPattern < >::getXmlTagName ( ) );

} /* namespace alib */
