#ifndef TREE_TEST_H_
#define TREE_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class TreeTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( TreeTest );
  CPPUNIT_TEST( testRankedTreeParser );
  CPPUNIT_TEST( testRankedTreeCompare );
  CPPUNIT_TEST( testRankedTreeSymbolValidityCheck );
  CPPUNIT_TEST( testUnrankedTreeParser );
  CPPUNIT_TEST( testUnrankedTreeCompare );
  CPPUNIT_TEST( testUnrankedTreeSymbolValidityCheck );

  CPPUNIT_TEST( testPrefixRankedBarParser );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testRankedTreeParser();
  void testRankedTreeCompare();
  void testRankedTreeSymbolValidityCheck();

  void testUnrankedTreeParser();
  void testUnrankedTreeCompare();
  void testUnrankedTreeSymbolValidityCheck();

  void testPrefixRankedBarParser();
};

#endif  // TREE_TEST_H_
