/*
 * LRParserTypes.h
 *
 *  Created on: 10. 5. 2016
 *	  Author: Martin Kocicka
 */

#ifndef LR_PARSER_TYPES_H_
#define LR_PARSER_TYPES_H_

#include <common/DefaultSymbolType.h>
#include <common/DefaultStateType.h>

#include <map>
#include <set>
#include <variant>
#include <vector>

namespace grammar {

namespace parsing {

enum class LRAction {
	Shift,
	Reduce,
	Accept
};

typedef std::map < DefaultSymbolType, std::set < std::pair < unsigned, std::vector < DefaultSymbolType > > > > LR0Items;
typedef std::map < std::pair < DefaultStateType, DefaultSymbolType >, std::pair < LRAction, ext::variant < DefaultStateType, std::pair < DefaultSymbolType, std::vector < DefaultSymbolType > > > > > LRActionTable;
typedef std::map < std::pair < DefaultStateType, DefaultSymbolType >, DefaultStateType > LRGotoTable;

} /* namespace parsing */

} /* namespace grammar */

#endif /* LR_PARSER_TYPES_H_ */
