/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROCESSOR_FILTER_HPP_
#define MEASUREMENT_PROCESSOR_FILTER_HPP_

#include <map>
#include <set>

namespace measurements {

class MeasurementProcessorFilter {
public:
	enum class FilterType {
		FRAME_TYPE,	FRAME_NAME,	COMMAND
	};

private:
	std::map < FilterType, std::set < std::string > > filters;

public:
	void add ( FilterType, const std::string & );
	void remove ( FilterType, const std::string & );
	bool matches ( FilterType, const std::string & ) const;
};

}

#endif /* MEASUREMENT_PROCESSOR_FILTER_HPP_ */
