/*
 * hexavigesimal.h
 *
 * Created on: 19. 4. 2014
 * Author: Tomas Pecka
 */

#ifndef __HEXAVIGESIMAL_H_
#define __HEXAVIGESIMAL_H_

#include <string>

namespace std {

/**
 * Maps 0 -> A, 1 -> B, ..., 25 -> Z, 26 -> AB, 27 -> AC, ..., 675 -> ZZ, 676 -> BAA, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
std::string toBase26( unsigned n );

/**
 * Maps A -> 0, B -> 0, ..., Z -> 25, AB -> 26, AC -> 27, ..., ZZ -> 675, BAA -> 676, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
unsigned fromBase26( std::string rep );

/**
 * Maps 1 -> A, 2 -> B, ..., 26 -> Z, 27 -> AA, 28 -> AB, ..., 675 -> ZZ, 676 -> BAA, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
std::string bijectiveToBase26( unsigned n );

/**
 * Maps 1 -> A, 2 -> B, ..., 26 -> Z, 27 -> AA, AB -> 28, ..., ZZ -> 675, BAA -> 676, ...
 * http://en.wikipedia.org/wiki/Hexavigesimal
 */
unsigned bijectiveFromBase26( std::string rep );

} /* namespace std */

#endif /* __HEXAVIGESIMAL_H_ */
