/*
 * string.hpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#ifndef __STRING_HPP_
#define __STRING_HPP_

#include <string>
#include <stdexcept>
#include "compare.hpp"

namespace ext {

template < typename T, typename std::enable_if < std::is_constructible < std::string, T >::value >::type* = nullptr >
std::string to_string ( const T & value ) {
	return (std::string) value;
}

std::string to_string ( const std::string & value );

std::string to_string ( int value );

std::string to_string ( bool value );

std::string to_string ( long value );

std::string to_string ( long long value );

std::string to_string ( unsigned value );

std::string to_string ( unsigned long value );

std::string to_string ( unsigned long long value );

std::string to_string ( double value );





template < typename T >
T from_string ( const std::string & );

template < >
std::string from_string ( const std::string & value );

template < >
int from_string ( const std::string & value );

template < >
bool from_string ( const std::string & value );

template < >
long from_string ( const std::string & value );

template < >
long long from_string ( const std::string & value );

template < >
unsigned from_string ( const std::string & value );

template < >
unsigned long from_string ( const std::string & value );

template < >
unsigned long long from_string ( const std::string & value );

template < >
double from_string ( const std::string & value );

std::string cstringToString ( char * param );

template < >
struct compare < std::string > {
	int operator ()( const std::string & first, const std::string & second ) const {
		return first.compare ( second );
	}

};

} /* namespace ext */

#endif /* __STRING_HPP_ */
