/*
 * LabelToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef LABEL_TO_STRING_COMPOSER_H_
#define LABEL_TO_STRING_COMPOSER_H_

#include <ostream>
#include <core/multipleDispatch.hpp>
#include "label/Label.h"
#include "label/LabelFeatures.h"

namespace label {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class LabelToStringComposer : public alib::SingleDispatchFirstStaticParam<LabelToStringComposer, void, std::ostream&, const LabelBase &> {
public:
	static void compose(std::ostream&, const PrimitiveLabel& label);
	static void compose(std::ostream&, const HexavigesimalLabel& label);
	static void compose(std::ostream&, const ObjectLabel& label);
	static void compose(std::ostream&, const UniqueLabel& label);
	static void compose(std::ostream&, const FailStateLabel& label);
	static void compose(std::ostream&, const InitialStateLabel& label);
	static void compose(std::ostream&, const FinalStateLabel& label);

	/**
	 * Prints text representation of Label to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	static void compose(std::ostream& output, const Label& string);
};

} /* namespace label */

#endif /* LABEL_TO_STRING_COMPOSER_H_ */
